         integer function calc_prim(tau, S, P, v, Gamma)

c------------------------------------------------------------
c Sun Jun 29 15:18:07 PDT 2003
c
c It calculates the primitive variables rho, v and P 
c from the conservative one tau and S
c
c------------------------------------------------------------

         implicit      none

         character*9   cdnm
         parameter   ( cdnm = 'calc_prim' ) 

         logical       ltrace
         parameter   ( ltrace = .false. )

         real*8       tau,    S
         real*8       rho,    v,  P
         real*8       Gamma

         real*8       beta

c============================================================
c============================================================
         if ( ltrace ) then
            write(0,*) cdnm,':   tau = ', tau
            write(0,*) cdnm,':     S = ', S
            write(0,*) cdnm,': Gamma = ', Gamma
         endif
         beta = 0.25d0 * (2.0d0 - Gamma) 
         P   = - 2.0d0 * beta * tau + 
     &          sqrt( 4.0d0 *beta**2 * tau**2+
     &                (Gamma-1.0d0) * (tau**2-S**2)
     &              )
         rho =  P / (Gamma-1.0d0)      
         v   =  S / (tau + P)
         if ( .not. (4.0d0 * beta**2 * tau**2 +
     &        (Gamma-1.0d0)*(tau**2-S**2) .ge. 0.0d0) ) then
            write(0,*) cdnm,': Non positive radical'
            write(0,*) cdnm,': tau =',tau
            write(0,*) cdnm,':   S =',S
            calc_prim = -1
            return
         endif
         if (tau+P .eq. 0.0d0) then
            write(0,*) cdnm,': Zero denominator'
            calc_prim = -2
            return
         endif
         calc_prim = 0
         return
         end

