
         include       'fcn_rw.inc'

         character*13  cdnm
         parameter   ( cdnm = 'exact_solver' )

         logical       ltrace
         parameter   ( ltrace = .false. )

         integer       j
         integer       Nxi

         real*8        shock_speed1, shock_speed2
         real*8        x_shock1,     x_shock2
         real*8        xbgn_rw,      xend_rw

         integer       Nx

         real*8        i,  i_prev,   ic
         real*8        xi_x
c============================================================
c============================================================
         if ( rho_xc .ne. v_xc ) then
            write(0,*) cdnm,': rho_xc <> v_xc'
            write(0,*) cdnm,': More that one Riemann problem'
            write(0,*) cdnm,': Stopping'
            write(0,*) cdnm,': (to solve the problem Use rho_xc=v_xc)'
            stop        
         endif
         if ( rho_L .lt. rho_R ) then
            write(0,*) cdnm,': this solver is not able'
            write(0,*) cdnm,': to handle rho_L < rho_R'
            write(0,*) cdnm,': Stopping'
            write(0,*) cdnm,': (to solve the problem '//
     &                      ' Reflect the system)'
            stop
         endif
         if ( xmin .ne. -1.0d0 .or. xmax .ne. 1.0d0 ) then
            write(0,*) cdnm,': BAD RANGE' 
            write(0,*) cdnm,': xmin=',xmin
            write(0,*) cdnm,': xmax=',xmax
            write(0,*) cdnm,': it can ONLY do xmin=-1.0'
            write(0,*) cdnm,': and            xmax=-1.0'
            write(0,*) cdnm,' Stopping'
            stop
         endif
         Nx    = g1_Nx  
         Nxi   = g1_Nx  
         rhoL  = rho_L
         rhoR  = rho_R
         vL    = v_L
         vR    = v_R

c-------------------------------------------------------
c  Calculation of the real shock.
c-------------------------------------------------------

         shock_speed1 = (SM-SR)/(tauM-tauR)
         shock_speed2 = (SM*vM+PM-SR*vR-PR)/(SM-SR)
         if ( shock_speed1 .lt. 0.0d0 ) then
            write(0,*) cdnm,': Negative shock speed!'
            stop
         endif
         if ( shock_speed2 .lt. 0.0d0 ) then
            write(0,*) cdnm,': Negative shock speed!'
            stop
         endif
         x_shock1 = shock_speed1 * T 
         x_shock2 = shock_speed2 * T 
         if ( ltrace ) then
            write(0,*) cdnm,': position shock x1=',x_shock1
            write(0,*) cdnm,': position shock x2=',x_shock2
         endif
         xbgn_rw = ximin * T
         xend_rw = ximax * T
         if ( ltrace ) then
            write(0,*) cdnm,': position rare. wave xi =',xbgn_rw
            write(0,*) cdnm,': position rare. wave xf =',xend_rw
         endif
         dx   =  (xmax - xmin)/(Nx-1)
         tau (1) = tauL 
         S   (1) = SL
         rho (1) = rhoL
         v   (1) = vL
         P   (1) = PL
         i_prev  = 1
         do j = 2, Nx
            x(j) = x(j-1) + dx
            if     ( x(j) .lt. xbgn_rw ) then
               tau (j) = tauL 
               S   (j) = SL 
               rho (j) = rhoL
               v   (j) = vL
               P   (j) = PL
            elseif ( x(j) .lt. xend_rw ) then  
               xi_x = x(j)/T 
               do i = i_prev, Nxi 
                  if( xi_x .lt. xi(i)) then
                    ic = i
                    goto 100
                  endif 
               enddo
100            continue
               tau (j) = tau2(ic-1) * (xi(ic)-xi_x)  /dxi +
     &                   tau2(ic)   * (xi_x  -xi(ic-1))/dxi
               S   (j) = S2(ic-1)   * (xi(ic)-xi_x)  /dxi +
     &                   S2(ic)     * (xi_x  -xi(ic-1))/dxi 
               i_prev = ic 
               call calc_prim(tau(j),S(j),P(j),v(j),Gamma)
               rho(j) = P(j)/(Gamma-1.0d0)
            elseif ( x(j) .lt. x_shock1 ) then
               tau (j) = tauM
               S   (j) = SM
               rho (j) = rhoM
               v   (j) = vM
               P   (j) = PM
            else
               tau (j) = tauR
               S   (j) = SR
               rho (j) = rhoR
               v   (j) = vR
               P   (j) = PR
            endif
         enddo 
         return 
